'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _recompose = require('recompose');

var _CTCGeneric = require('./CTCGeneric');

var _CTCGeneric2 = _interopRequireDefault(_CTCGeneric);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CTCMercury = function CTCMercury(_ref) {
  var _ref$colors = _ref.colors,
      colors = _ref$colors === undefined ? 'neutral' : _ref$colors,
      _ref$subcolors = _ref.subcolors,
      subcolors = _ref$subcolors === undefined ? '' : _ref$subcolors,
      _ref$maxHeight = _ref.maxHeight,
      maxHeight = _ref$maxHeight === undefined ? '100vh' : _ref$maxHeight,
      _ref$subtype = _ref.subtype,
      subtype = _ref$subtype === undefined ? 'horizontal' : _ref$subtype,
      _ref$containerProps = _ref.containerProps,
      containerProps = _ref$containerProps === undefined ? {} : _ref$containerProps,
      renderTrigger = _ref.renderTrigger,
      transitionProps = _ref.transitionProps,
      renderIcon = _ref.renderIcon,
      shouldRenderIcon = _ref.shouldRenderIcon,
      children = _ref.children,
      defaultIsOn = _ref.defaultIsOn,
      externalIsOn = _ref.externalIsOn,
      size = _ref.size,
      sizeFontRatio = _ref.sizeFontRatio,
      props = (0, _objectWithoutProperties3.default)(_ref, ['colors', 'subcolors', 'maxHeight', 'subtype', 'containerProps', 'renderTrigger', 'transitionProps', 'renderIcon', 'shouldRenderIcon', 'children', 'defaultIsOn', 'externalIsOn', 'size', 'sizeFontRatio']);

  return _react2.default.createElement(
    _CTCGeneric2.default,
    (0, _extends3.default)({ externalIsOn: externalIsOn, defaultIsOn: defaultIsOn }, props),
    function (_ref2) {
      var getChildrenProps = _ref2.getChildrenProps,
          elClickListenerRef = _ref2.elClickListenerRef,
          getContainerProps = _ref2.getContainerProps,
          getTriggerProps = _ref2.getTriggerProps,
          isOn = _ref2.isOn;

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({
          ref: elClickListenerRef
        }, getContainerProps((0, _extends3.default)({
          className: (0, _helperFunctions.flippyClass)(isOn, 'ctcmercury__container', 'show', 'hide')
        }, containerProps))),
        _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            subtype: subtype,

            subcolors: subcolors,
            type: 'mercurydrop',
            colors: colors,
            renderIcon: renderIcon,
            shouldRenderIcon: shouldRenderIcon
          }, getTriggerProps({ isOn: isOn }), {
            size: size,
            sizeFontRatio: sizeFontRatio
          }, props),
          renderTrigger && renderTrigger()
        ),
        _react2.default.createElement(
          _RTGTransition2.default,
          (0, _extends3.default)({
            in: isOn,
            duration: 0,
            transitionType: ['height', 'fade'],
            maxHeight: maxHeight
          }, transitionProps),
          function (_ref3) {
            var transitionStyle = _ref3.style;
            return children({ getChildrenProps: getChildrenProps, transitionStyle: transitionStyle, isOn: isOn });
          }
        )
      );
    }
  );
};

var enhance = (0, _recompose.compose)();

exports.default = enhance(CTCMercury);