'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  background: #ddf;\n  display: flex;\n  @media (', '-width: ', 'px) {\n    display: none;\n  }\n'], ['\n  background: #ddf;\n  display: flex;\n  @media (', '-width: ', 'px) {\n    display: none;\n  }\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  position: relative;\n  background: #fdd;\n  @media (', '-width: ', 'px) {\n    display: none;\n  }\n'], ['\n  position: relative;\n  background: #fdd;\n  @media (', '-width: ', 'px) {\n    display: none;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGMenu = require('./svg/SVGMenu');

var _SVGMenu2 = _interopRequireDefault(_SVGMenu);

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ABOVE_THRESHOLD = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var isInverted = _ref.isInverted;
  return !isInverted ? 'max' : 'min';
}, function (_ref2) {
  var threshold = _ref2.threshold;
  return threshold;
});
var BELOW_THRESHOLD = (0, _styledComponents2.default)('div')(_templateObject2, function (_ref3) {
  var isInverted = _ref3.isInverted;
  return !isInverted ? 'min' : 'max';
}, function (_ref4) {
  var threshold = _ref4.threshold;
  return threshold;
});

var FlexibleMenu = function FlexibleMenu(_ref5) {
  var _ref5$threshold = _ref5.threshold,
      threshold = _ref5$threshold === undefined ? 600 : _ref5$threshold,
      _ref5$isInverted = _ref5.isInverted,
      isInverted = _ref5$isInverted === undefined ? false : _ref5$isInverted,
      children = _ref5.children,
      renderHorizontal = _ref5.renderHorizontal,
      pivotFrom = _ref5.pivotFrom,
      renderTrigger = _ref5.renderTrigger,
      debugMode = _ref5.debugMode;

  return _react2.default.createElement(
    _react.Fragment,
    null,
    _react2.default.createElement(HorizontalMenu, { children: children, renderHorizontal: renderHorizontal, threshold: threshold, isInverted: isInverted }),
    _react2.default.createElement(DropdownMenu, {
      threshold: threshold,
      isInverted: isInverted,
      children: children,
      pivotFrom: pivotFrom,
      renderTrigger: renderTrigger,
      debugMode: debugMode
    })
  );
};

var HorizontalMenu = function HorizontalMenu(_ref6) {
  var threshold = _ref6.threshold,
      children = _ref6.children,
      renderHorizontal = _ref6.renderHorizontal,
      isInverted = _ref6.isInverted;
  return _react2.default.createElement(
    ABOVE_THRESHOLD,
    {
      threshold: threshold,
      isInverted: isInverted,
      className: 'flexiblemenu__horizontal'
    },
    renderHorizontal ? renderHorizontal() : children
  );
};

var triggerBaseClassName = 'flexiblemenu__trigger';
var defaultRenderTrigger = function defaultRenderTrigger(_ref7) {
  var getTriggerProps = _ref7.getTriggerProps,
      isOn = _ref7.isOn;
  return _react2.default.createElement(
    _Button2.default,
    (0, _extends3.default)({}, getTriggerProps({
      className: triggerBaseClassName,
      isOn: isOn
    })),
    _react2.default.createElement(_SVGMenu2.default, null)
  );
};

var DropdownMenu = function DropdownMenu(_ref8) {
  var threshold = _ref8.threshold,
      children = _ref8.children,
      pivotFrom = _ref8.pivotFrom,
      _renderTrigger = _ref8.renderTrigger,
      debugMode = _ref8.debugMode,
      isInverted = _ref8.isInverted;

  return _react2.default.createElement(
    BELOW_THRESHOLD,
    {
      className: 'flexiblemenu__dropdown',
      threshold: threshold,
      isInverted: isInverted
    },
    _react2.default.createElement(
      _CTCPopover2.default,
      {
        debugMode: debugMode,
        pivotFrom: pivotFrom,
        renderTrigger: function renderTrigger(_ref9) {
          var _getTriggerProps = _ref9.getTriggerProps,
              isOn = _ref9.isOn;
          return _renderTrigger ? _renderTrigger({
            getTriggerProps: function getTriggerProps() {
              var _ref10 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              var className = _ref10.className,
                  props = (0, _objectWithoutProperties3.default)(_ref10, ['className']);
              return _getTriggerProps((0, _extends3.default)({
                className: !className ? triggerBaseClassName : [triggerBaseClassName, className]
              }, props));
            },
            isOn: isOn
          }) : defaultRenderTrigger({ getTriggerProps: _getTriggerProps, isOn: isOn });
        }
      },
      children
    )
  );
};

exports.default = _react2.default.memo(FlexibleMenu);