"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectOne = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require("./defaultStyles");

var _recompose = require("recompose");

var _helperFunctions = require("./helperFunctions");

var _CTCPopover = require("./CTCPopover");

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _Button = require("./Button");

var _Button2 = _interopRequireDefault(_Button);

var _StyledSelect = require("./StyledSelect");

var _OutsideClickListener = require("./OutsideClickListener");

var _KBListener = require("./KBListener");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectOne = function SelectOne(_ref) {
  var externalIsOn = _ref.externalIsOn,
      setExternalIsOnTo = _ref.setExternalIsOnTo,
      _ref$alwaysOn = _ref.alwaysOn,
      alwaysOn = _ref$alwaysOn === undefined ? false : _ref$alwaysOn,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === undefined ? function () {
    return null;
  } : _ref$onClick,
      _ref$maxHeight = _ref.maxHeight,
      maxHeight = _ref$maxHeight === undefined ? 20 : _ref$maxHeight,
      _ref$showCurrentOptio = _ref.showCurrentOption,
      showCurrentOption = _ref$showCurrentOptio === undefined ? false : _ref$showCurrentOptio,
      onChange = _ref.onChange,
      children = _ref.children,
      _renderTrigger = _ref.renderTrigger,
      defaultCurrentOption = _ref.defaultCurrentOption,
      externalCurrentOption = _ref.externalCurrentOption,
      options = _ref.options,
      _ref$pivotFrom = _ref.pivotFrom,
      pivotFrom = _ref$pivotFrom === undefined ? "DOWNRIGHT" : _ref$pivotFrom,
      props = (0, _objectWithoutProperties3.default)(_ref, ["externalIsOn", "setExternalIsOnTo", "alwaysOn", "onClick", "maxHeight", "showCurrentOption", "onChange", "children", "renderTrigger", "defaultCurrentOption", "externalCurrentOption", "options", "pivotFrom"]);

  var _useSafeSetState = (0, _helperFunctions.useSafeSetState)({
    currentOption: defaultCurrentOption ? defaultCurrentOption : options[0],
    isOn: false
  }),
      _useSafeSetState2 = (0, _slicedToArray3.default)(_useSafeSetState, 2),
      state = _useSafeSetState2[0],
      setState = _useSafeSetState2[1];

  var currentOption = state.currentOption,
      isOn = state.isOn;

  //console.log(currentOption)

  var setCurrentOptionTo = function setCurrentOptionTo(arg) {
    return setState({ currentOption: arg });
  };
  var setIsOnTo = function setIsOnTo(arg) {
    setState({ isOn: arg });
    setExternalIsOnTo && setExternalIsOnTo(arg);
  };
  (0, _react.useEffect)(function () {
    if (setExternalIsOnTo && externalIsOn !== isOn) {
      setState({ isOn: externalIsOn });
    }
  }, [externalIsOn]);

  (0, _react.useEffect)(function () {
    if (externalCurrentOption && externalCurrentOption.value !== currentOption.value) {
      setState({ currentOption: externalCurrentOption });
    }
  }, [externalCurrentOption]);

  var isActive = function isActive(option) {
    return option.value === currentOption.value;
  };

  var getChildProps = function getChildProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ["className", "style", "onClick", "option"]);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        // console.log(option, currentOption)
        e.stopPropagation();
        setCurrentOptionTo(option);
        onChange(option);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), "selectone__option", "active", "inactive") + " " + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, "active", "inactive") : ""),
      style: (0, _extends3.default)({
        display: showCurrentOption === false && isActive(option) ? "none" : "flex"
      }, style)
    }, props);
  };
  // const { elClickListenerRef } = useOutsideClickListener({
  //   outsideHandler: () => setComponentIsActiveTo(false),
  //   insideHandler: () => setComponentIsActiveTo(true),
  // })
  //const uOCLHandlers = {
  //  outsideHandler: (el, e) => {
  //    console.log("outsideHandler", el, e && e.target)
  //    setComponentIsActiveTo(false)
  //  },
  //  insideHandler: (el, e) => {
  //    console.log("insideHandler", el, e && e.target)
  //    setComponentIsActiveTo(true)
  //  },
  //}
  var currentOptionIndex = options.findIndex(function (option) {
    return currentOption && option && currentOption.value === option.value;
  });

  var nextOptionIndex = currentOptionIndex === options.length - 1 ? 0 : currentOptionIndex + 1;
  var prevOptionIndex = currentOptionIndex === 0 ? options.length - 1 : currentOptionIndex - 1;
  // console.log(currentOptionIndex, nextOptionIndex, prevOptionIndex)
  (0, _KBListener.useKBListener)({
    keyCodes: [[38, function () {
      if (isOn) {
        //console.log(nextOptionIndex)
        onChange(options[nextOptionIndex]);
        setCurrentOptionTo(options[nextOptionIndex]);
      }
    }], [40, function () {
      if (isOn) {
        //console.log(prevOptionIndex)
        onChange(options[prevOptionIndex]);
        setCurrentOptionTo(options[prevOptionIndex]);
      }
    }]]
  });
  //useEffect(() => console.log(isOn), [isOn])
  return _react2.default.createElement(
    _CTCPopover2.default,
    (0, _extends3.default)({
      //externalRef: elClickListenerRef,
      connected: true,
      externalIsOn: isOn,
      setExternalIsOnTo: setIsOnTo,
      renderTrigger: function renderTrigger(_ref3) {
        var isOn = _ref3.isOn,
            _getTriggerProps = _ref3.getTriggerProps;

        var defaultTriggerClassName = (0, _helperFunctions.flippyClass)(isOn, "selectone__trigger", "on", "off");
        return _renderTrigger ? _renderTrigger({
          currentOption: currentOption,
          isOn: alwaysOn ? true : isOn,
          getTriggerProps: function getTriggerProps() {
            var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var className = _ref4.className,
                props = (0, _objectWithoutProperties3.default)(_ref4, ["className"]);
            return _getTriggerProps((0, _extends3.default)({
              className: className ? className + " " + defaultTriggerClassName : defaultTriggerClassName
            }, props));
          }
        }) : _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            type: "caretdown",
            isOn: alwaysOn ? true : isOn
          }, _getTriggerProps({
            className: defaultTriggerClassName
          }), {
            colors: _defaultStyles.buttonStyles.transparentNeutral
          }),
          currentOption ? currentOption.label : options[0].label
        );
      },
      alwaysOn: alwaysOn,
      pivotFrom: pivotFrom
    }, props),
    function (_ref5) {
      var _getChildrenProps = _ref5.getChildrenProps,
          isOn = _ref5.isOn,
          setIsOnTo = _ref5.setIsOnTo,
          toggleIsOn = _ref5.toggleIsOn;

      var defaultChildrenClassName = "selectone__children";

      return typeof children === "function" ? children({
        getChildProps: getChildProps,
        getChildrenProps: function getChildrenProps() {
          var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          var className = _ref6.className,
              props = (0, _objectWithoutProperties3.default)(_ref6, ["className"]);
          return _getChildrenProps((0, _extends3.default)({
            className: className ? className + " " + defaultChildrenClassName : defaultChildrenClassName
          }, props));
        },
        isOn: isOn,
        setIsOnTo: setIsOnTo,
        toggleIsOn: toggleIsOn,
        currentOption: currentOption
      }) : _react2.default.createElement(
        _StyledSelect.DROPDOWN_CHILDREN,
        (0, _extends3.default)({}, _getChildrenProps({
          className: defaultChildrenClassName
        }), {
          maxHeight: maxHeight
        }),
        children.map(function (option) {
          return _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getChildProps({
              option: option,
              onClick: toggleIsOn
            }), {
              colors: _defaultStyles.buttonStyles.neutral,
              isOn: isActive(option),
              key: option.value
            }),
            option.label
          );
        })
      );
    }
  );
};

exports.SelectOne = SelectOne;
exports.default = SelectOne;