"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _taggedTemplateLiteral2 = require("babel-runtime/helpers/taggedTemplateLiteral");

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(["\n  display: flex;\n  flex-direction: ", ";\n  align-items: center;\n  justify-content: center;\n"], ["\n  display: flex;\n  flex-direction: ", ";\n  align-items: center;\n  justify-content: center;\n"]),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(["\n  position: relative;\n  display: flex;\n  justify-content: center;\n"], ["\n  position: relative;\n  display: flex;\n  justify-content: center;\n"]),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(["\n  background-position: center;\n  background-repeat: no-repeat;\n  background-size: auto 8rem;\n  min-width: 5rem;\n  min-height: 8rem;\n"], ["\n  background-position: center;\n  background-repeat: no-repeat;\n  background-size: auto 8rem;\n  min-width: 5rem;\n  min-height: 8rem;\n"]),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(["\n  align-items: center;\n  position: relative;\n  display: flex;\n  flex-direction: ", ";\n"], ["\n  align-items: center;\n  position: relative;\n  display: flex;\n  flex-direction: ", ";\n"]),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(["\n  width: ", ";\n  overflow-x: hidden;\n  overflow-y: hidden;\n  display: flex;\n  align-items: center;\n"], ["\n  width: ", ";\n  overflow-x: hidden;\n  overflow-y: hidden;\n  display: flex;\n  align-items: center;\n"]),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(["\n  margin-right: ", ";\n"], ["\n  margin-right: ", ";\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Button = require("./Button");

var _Button2 = _interopRequireDefault(_Button);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NEXT = "NEXT";
var PREV = "PREV";
var GOTO = "GOTO";

var CONTAINER = _styledComponents2.default.div.attrs(function (_ref) {
  var style = _ref.style;
  return {
    style: style
  };
})(_templateObject, function (_ref2) {
  var layout = _ref2.layout;
  return layout === "vertical" ? "row" : "column";
});

var MAIN_FRAME = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: "imageviewer__mainframe"
  };
})(_templateObject2);

var PREVIEW_BUTTON = (0, _styledComponents2.default)(_Button2.default).attrs(function (_) {
  return {
    className: "imageviewer__previewbutton"
  };
})(_templateObject3);

var PREVIEW_FRAME = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: "imageviewer__previewframe"
  };
})(_templateObject4, function (_ref3) {
  var layout = _ref3.layout;
  return layout === "vertical" ? "column" : "row";
});

var PREVIEW_ACCORDION = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: "imageviewer__previewaccordion"
  };
})(function (_ref4) {
  var layout = _ref4.layout,
      previewImageWidth = _ref4.previewImageWidth,
      mainImageWidth = _ref4.mainImageWidth,
      previewImageHeight = _ref4.previewImageHeight,
      mainImageMaxHeight = _ref4.mainImageMaxHeight,
      srcsLength = _ref4.srcsLength;
  return {
    overflow: "hidden",
    display: "flex",
    flexDirection: layout === "vertical" ? "column" : "row",
    width: layout === "vertical" ? "auto" : srcsLength * previewImageWidth > mainImageWidth ? mainImageWidth : srcsLength * previewImageWidth,
    height: layout === "vertical" ? srcsLength * previewImageHeight > mainImageMaxHeight ? mainImageMaxHeight : srcsLength * previewImageHeight : "auto"
  };
});

var MAIN_IMAGE_FRAME = _styledComponents2.default.div(_templateObject5, function (_ref5) {
  var imageWidth = _ref5.imageWidth;
  return imageWidth + "px";
});
var MAIN_IMAGE = _styledComponents2.default.div(_templateObject6, function (_ref6) {
  var imageMargin = _ref6.imageMargin;
  return imageMargin;
});

var sharedLargeNavButtonStyle = {
  position: "absolute",
  top: 0,
  padding: 0,
  zIndex: 1
};

var LARGE_NAV_BUTTON = (0, _styledComponents2.default)(_Button2.default)(function (_ref7) {
  var layout = _ref7.layout,
      disableDiscreteNavButtons = _ref7.disableDiscreteNavButtons,
      previewImageHeight = _ref7.previewImageHeight,
      mainImageMaxHeight = _ref7.mainImageMaxHeight,
      previewImageWidth = _ref7.previewImageWidth,
      mainImageWidth = _ref7.mainImageWidth,
      dir = _ref7.dir,
      srcsLength = _ref7.srcsLength;
  return layout === "vertical" ? (0, _extends3.default)({}, sharedLargeNavButtonStyle, {
    display: disableDiscreteNavButtons ? "none" : srcsLength * previewImageHeight > mainImageMaxHeight ? "flex" : "none",
    top: dir === PREV ? -30 : "auto",
    bottom: dir === NEXT ? -30 : "auto",
    width: "100%",
    height: 30
  }) : (0, _extends3.default)({}, sharedLargeNavButtonStyle, {
    display: disableDiscreteNavButtons ? "none" : srcsLength * previewImageWidth > mainImageWidth ? "flex" : "none",
    left: dir === PREV ? -30 : "auto",
    right: dir === NEXT ? -30 : "auto",
    height: "100%",
    width: 30
  });
});

var sharedSmallNavButtonStyles = {
  display: "flex",
  height: "1rem",
  width: "1rem",
  // height: `100%`,
  // margin: "0 1.75rem",
  // border: "1px solid white",
  padding: "1rem",
  zIndex: 1
};

var SMALL_NAV_BUTTON = (0, _styledComponents2.default)(_Button2.default)(function () {
  return (0, _extends3.default)({}, sharedSmallNavButtonStyles);
});

exports.default = {
  CONTAINER: CONTAINER,
  MAIN_FRAME: MAIN_FRAME,
  PREVIEW_BUTTON: PREVIEW_BUTTON,
  PREVIEW_FRAME: PREVIEW_FRAME,
  PREVIEW_ACCORDION: PREVIEW_ACCORDION,
  MAIN_IMAGE_FRAME: MAIN_IMAGE_FRAME,
  MAIN_IMAGE: MAIN_IMAGE,
  SMALL_NAV_BUTTON: SMALL_NAV_BUTTON,
  LARGE_NAV_BUTTON: LARGE_NAV_BUTTON
};