"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactTable = require("react-table");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Table = function Table(_ref) {
  var data = _ref.data,
      columns = _ref.columns;

  var _useTable = (0, _reactTable.useTable)({ data: data, columns: columns }),
      getTableProps = _useTable.getTableProps,
      getTableBodyProps = _useTable.getTableBodyProps,
      headerGroups = _useTable.headerGroups,
      rows = _useTable.rows,
      prepareRow = _useTable.prepareRow;

  return _react2.default.createElement(
    "div",
    null,
    _react2.default.createElement(
      "table",
      getTableProps(),
      _react2.default.createElement(
        "thead",
        null,
        headerGroups.map(function (headerGroup) {
          return _react2.default.createElement(
            "tr",
            headerGroup.getHeaderGroupProps(),
            headerGroup.headers.map(function (column) {
              return _react2.default.createElement(
                "th",
                column.getHeaderProps(),
                column.render("Header")
              );
            })
          );
        })
      ),
      _react2.default.createElement(
        "tbody",
        getTableBodyProps(),
        rows.map(function (row) {
          prepareRow(row);
          return _react2.default.createElement(
            "tr",
            row.getRowProps(),
            row.cells.map(function (cell) {
              return _react2.default.createElement(
                "td",
                cell.getCellProps(),
                cell.render("Cell")
              );
            })
          );
        })
      )
    )
  );
};

exports.default = Table;